include "basics/pts.ma".
include "connectives.ma".
include "leibniz.ma".
include "logic.ma".
axiom nat : Type[0].
axiom O : nat.
axiom S : nat -> nat.
axiom filter_nat_type : \forall return_ : Type[0] . (nat -> return_) -> nat -> return_.
axiom axiom_filter_nat_type_O : \forall return_type. \forall (return_:nat -> return_type). (equal) (return_type) ((filter_nat_type) (return_type) return_ (O) ) (return_ (O) ).
definition eq_filter_nat_type_O : \forall return_type. \forall (return_:nat -> return_type). (leibniz) (return_type) ((filter_nat_type) (return_type) return_ (O) ) (return_ (O) ) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. ((((equal_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ (O) )) (return_ (O) )) (((axiom_filter_nat_type_O) (return_type)) (return_)).
definition sym_eq_filter_nat_type_O : \forall return_type. \forall (return_:nat -> return_type). (leibniz) (return_type) (return_ (O) ) ((filter_nat_type) (return_type) return_ (O) ) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. ((((sym_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ (O) )) (return_ (O) )) (((eq_filter_nat_type_O) (return_type)) (return_)).
axiom axiom_filter_nat_type_S : \forall return_type. \forall (return_:nat -> return_type). \forall (n:nat). (equal) (return_type) ((filter_nat_type) (return_type) return_ ((S)  n)) (return_ ((S)  n)).
definition eq_filter_nat_type_S : \forall return_type. \forall (return_:nat -> return_type). \forall (n:nat). (leibniz) (return_type) ((filter_nat_type) (return_type) return_ ((S)  n)) (return_ ((S)  n)) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. \lambda n : nat. ((((equal_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ ((S)  n))) (return_ ((S)  n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
definition sym_eq_filter_nat_type_S : \forall return_type. \forall (return_:nat -> return_type). \forall (n:nat). (leibniz) (return_type) (return_ ((S)  n)) ((filter_nat_type) (return_type) return_ ((S)  n)) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. \lambda n : nat. ((((sym_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ ((S)  n))) (return_ ((S)  n))) ((((eq_filter_nat_type_S) (return_type)) (return_)) (n)).
axiom nat_ind : \forall (Q:nat -> Prop). (Q (O) ) -> (\forall (x:nat). (Q x) -> Q ((S)  x)) -> \forall (x:nat). Q x.
axiom plus : nat -> nat -> nat.
axiom plus_body : nat -> nat -> nat.
axiom axiom_plus : \forall (n:nat). (equal) (nat -> nat) ((plus)  n) ((filter_nat_type) (nat -> nat) (plus_body)  n).
definition eq_plus : \forall (n:nat). (leibniz) (nat -> nat) ((plus)  n) ((filter_nat_type) (nat -> nat) (plus_body)  n) := \lambda n : nat. ((((equal_leibniz) (nat -> nat)) ((plus)  n)) ((filter_nat_type) (nat -> nat) (plus_body)  n)) ((axiom_plus) (n)).
definition sym_eq_plus : \forall (n:nat). (leibniz) (nat -> nat) ((filter_nat_type) (nat -> nat) (plus_body)  n) ((plus)  n) := \lambda n : nat. ((((sym_leibniz) (nat -> nat)) ((plus)  n)) ((filter_nat_type) (nat -> nat) (plus_body)  n)) ((eq_plus) (n)).
axiom axiom_plus_body_O : (equal) (nat -> nat) ((plus_body)  (O) ) (\lambda m : nat. m).
definition eq_plus_body_O : (leibniz) (nat -> nat) ((plus_body)  (O) ) (\lambda m : nat. m) := ((((equal_leibniz) (nat -> nat)) ((plus_body)  (O) )) (\lambda m : nat. m)) (axiom_plus_body_O).
definition sym_eq_plus_body_O : (leibniz) (nat -> nat) (\lambda m : nat. m) ((plus_body)  (O) ) := ((((sym_leibniz) (nat -> nat)) ((plus_body)  (O) )) (\lambda m : nat. m)) (eq_plus_body_O).
axiom axiom_plus_body_S : \forall (n:nat). (equal) (nat -> nat) ((plus_body)  ((S)  n)) (\lambda m : nat. (S)  ((plus)  n m)).
definition eq_plus_body_S : \forall (n:nat). (leibniz) (nat -> nat) ((plus_body)  ((S)  n)) (\lambda m : nat. (S)  ((plus)  n m)) := \lambda n : nat. ((((equal_leibniz) (nat -> nat)) ((plus_body)  ((S)  n))) (\lambda m : nat. (S)  ((plus)  n m))) ((axiom_plus_body_S) (n)).
definition sym_eq_plus_body_S : \forall (n:nat). (leibniz) (nat -> nat) (\lambda m : nat. (S)  ((plus)  n m)) ((plus_body)  ((S)  n)) := \lambda n : nat. ((((sym_leibniz) (nat -> nat)) ((plus_body)  ((S)  n))) (\lambda m : nat. (S)  ((plus)  n m))) ((eq_plus_body_S) (n)).
definition plus_n_O : \forall (n:nat). (eq) (nat) n ((plus)  n (O) ) := \lambda n : nat. ((((nat_ind) (\lambda j_x_365 : nat. (eq) (nat) j_x_365 ((plus)  j_x_365 (O) ))) ((((sym_eq_plus) ((O) )) (\lambda y : nat -> nat. (eq) (nat) (O)  (y (O) ))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) ((plus_body) )) (\lambda y : nat -> nat. (eq) (nat) (O)  (y (O) ))) (((sym_eq_plus_body_O) (\lambda y : nat -> nat. (eq) (nat) (O)  (y (O) ))) (((refl) (nat)) ((O) )))))) (\lambda x_366 : nat. \lambda j_x_368 : (eq) (nat) x_366 ((plus)  x_366 (O) ). ((((sym_eq_plus) ((S)  x_366)) (\lambda y : nat -> nat. (eq) (nat) ((S)  x_366) (y (O) ))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) ((plus_body) )) (x_366)) (\lambda y : nat -> nat. (eq) (nat) ((S)  x_366) (y (O) ))) ((((sym_eq_plus_body_S) (x_366)) (\lambda y : nat -> nat. (eq) (nat) ((S)  x_366) (y (O) ))) (((((((rewrite_l) (nat)) (x_366)) (\lambda j__ : nat. (eq) (nat) ((S)  x_366) ((S)  j__))) (((refl) (nat)) ((S)  x_366))) ((plus)  x_366 (O) )) (j_x_368))))))) (n).
